#ifndef IOCTLS_H
#define IOCTLS_h

#pragma once

#include "stdafx.h"

extern "C"
{
	NTSTATUS GetDesktopCount(PIRP pIrp, ULONG_PTR* pulpBytesWritten);
	NTSTATUS GetDesktopInfo(PIRP pIrp, ULONG_PTR* pulpBytesWritten);
	BOOLEAN CheckPtrPtrValidity(PVOID* ppAddress);
	BOOLEAN CheckEResourceValidity(PERESOURCE* ppEResource);
}

typedef struct _DeskCountInput
{
	ULONG signature;
	HANDLE hWinSta;
	// the next member is a pointer to a 36 byte user mode buffer (on x86)
	// containing win32k file version among other things, but it's never used
	PVOID unused;
} DeskCountInput;

static const ULONG dwDeskCountSignature = 0xDEADDEAD;

static const ULONG IOCTL_DHEAPMON_COUNT_DESKTOP	= CTL_CODE(FILE_DEVICE_UNKNOWN, 1, METHOD_BUFFERED, FILE_READ_ACCESS);
static const ULONG IOCTL_DHEAPMON_GET_DESKTOP_INFO = CTL_CODE(FILE_DEVICE_UNKNOWN, 2, METHOD_BUFFERED, FILE_READ_ACCESS);

#ifdef ALLOC_PRAGMA
#pragma alloc_text(PAGE, GetDesktopCount, CheckEResourceValidity)
#pragma alloc_text(PAGE, GetDesktopInfo, CheckPtrPtrValidity)
#endif

#endif
